/************************************   Email   ********************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*		 For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.2 $ 
*				 
*******************************************************************************/
import java.util.*;
import java.sql.*;
import org.jdom.Element;

public class Email{

	/** Private Fields */
	private int  PKEY;
	private String Address; 
	private String Komment;
	private ArrayList Groups = new ArrayList(5);
	
	/** Boolean indicates if values changed */
	public boolean Modified = false;

	/** Initalize new Email with data from Database */
	public Email(String myadr, String mykomment, int mypkey){
		this.Address = myadr;
		this.PKEY	 = mypkey;
		this.Komment = (mykomment == null)  ? "" : mykomment;
	}

	/** Unique ID = Primary Key */
	public int getPKEY(){
		return this.PKEY;
	}
	/**  get private emailaddress for display in lists */
	public String toString(){
		return this.Address ;	
	}
	/**  get private emailaddress field */
	public String getAddress(){
		return this.Address;
	}
	/**  get private comment for each email */
	public String getKomment(){
		return this.Komment;
	}
	
	/**  get groups each email entity belongs to  */
	public ArrayList getGroups(){
		return this.Groups;
	}
	
	/** int[] with indices of Vector AddMan.getGroups()
		for JList Group_list.setSelectedIndices(int[])
	*/
	public int[] getGroupIndices(){
		ArrayList globalgroups = AddMan.getGroups();
		int[] grpindices = new int[this.Groups.size()];  
		int j = 0 ;
		for(int i =0 ; i < globalgroups.size() ; i++){
			if(this.Groups.contains(globalgroups.get(i))){
				grpindices[j] = i;
				j++;
			}
		} 
		return grpindices;
	}

	/** set emailaddress */
	public void setAddress(String myaddress){
		this.Address = myaddress ;
		this.Modified = true;
	}
	
	/** set comment for emailaddress */
	public void setKomment(String mykomment){
		this.Komment = mykomment;
		this.Modified = true;
	}
	


	/** 
	 * register at all groups this email entity belongs to 
	 * read Data from org.Jdom.Element 
	*/ 
	public void RegisterAtGroups(Element myElement){
		/** get memberships in groups */
		List Grouptree = myElement.getChildren();
		Iterator it = Grouptree.iterator();
		while(it.hasNext()){ 	
			Element GroupElement = (Element)it.next();
			((Group)AddMan.GroupHash.get(new Integer(GroupElement.getAttributeValue("PKEY")))).RegisterEmail(this);
			this.Groups.add((Group)AddMan.GroupHash.get(new Integer(GroupElement.getAttributeValue("PKEY"))));
		}
	}


	
/*
* Methods to modify data in Memory without writing Database entries
*/
	/**
	 * Redefine Groupmembership in Memory for Later saving in File
	 */
	public void setGroups(Object[] groupselection){
		ArrayList newGroups = new ArrayList(5);
		for(int i = 0; i < groupselection.length ; i++){
			try{newGroups.add((Group)groupselection[i]);}
			catch(ArrayIndexOutOfBoundsException exc){
				AddMan.win.showErrorMessage("[Email.setGroups()] " + exc.getMessage());
			}		
		}
		// Only if something has Changed
		if(! newGroups.equals(this.Groups)){
			//Check the Groups to be removed
			for(int i = 0 ; i < this.Groups.size(); i++){
				if(! newGroups.contains(this.Groups.get(i))){
					UnregisterMembership((Group)this.Groups.get(i));
				}
			}
			// Check the goups to be added
			for(int i =0 ; i< newGroups.size(); i++){
				if(! this.Groups.contains(newGroups.get(i))){
					RegisterMembership((Group)newGroups.get(i));
				}
			} 	
		}
	}

	/** 
	 * register new groupmembership 
	*/
	public void RegisterMembership(Group newgroup){
		newgroup.RegisterEmail(this);
		this.Groups.add(newgroup);
	}

	
	/** 
	 * revoke membership in group @param 
	 * while the group continues to exist
	*/
	public void UnregisterMembership(Group oldgroup){
		oldgroup.UnregisterEmail(this);
		this.Groups.remove(oldgroup);
	}

	/** 
	* revoke membership in group @param  
	* while this email continues to exist and the group is deleted
	*/
	public void GroupDeleted(Group oldgroup){
		this.Groups.remove(oldgroup);
	}

}
