/***********************************  Fenster   *********************************
 * Java-Addressmanager - Frontend for managing personal contacts
 * Copyright (c) 2002  - Thomas Ruschival 
 *   For  license details read LICENSE
 * CVS:
 * $Author: ruschi $
 * $Date: 2004/09/14 15:33:04 $
 * $Revision: 1.2 $ 
 *     
 *******************************************************************************/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
import java.io.File;

class Fenster extends JFrame{
	/** ControlModule */
	FensterControl Control;    
	/** SelectionMode describes whether Users or Groups are shown -> AddMan.Selectionmode */
	int Selectionmode = AddMan.USERSELECTIONMODE;

	/** Contentpane */
    private Container  rahmen;
    private JDialog  ExitDialog;

    /** panels */
    private JPanel KisteLinks  = new JPanel();
    private JPanel KisteUnten  = new JPanel();
    private JTabbedPane KisteMitte = new JTabbedPane();
  
    /** UserList / global Grouplist in left frame */
    public  JList UserList   = new JList();
    private JScrollPane UserScroll  = new JScrollPane(UserList); 
    public JList globGroupList = new JList();
    private JScrollPane globGroupScroll = new JScrollPane(globGroupList);
    private FeldLabel lab_listtitle = new FeldLabel("Contacts:");
 
    // Tabs
    private JPanel General_tab= new JPanel();
    private JPanel Mail_tab   = new JPanel();
    private JPanel Email_tab  = new JPanel();
    private JPanel Phone_tab  = new JPanel();
    private JPanel Groups_tab = new JPanel();
    private JPanel Other_tab  = new JPanel();
  
    // MenuBar und Menus
    private JMenuBar MenuBar  = new JMenuBar();
    private JMenu FileMenu   = new JMenu("File");
    private JMenu NewItems  = new JMenu("New");
    private JMenu EditMenu   = new JMenu("Edit");
    private JMenu ViewMenu   = new JMenu("View");
    private JMenu ToolsMenu   = new JMenu("Tools");
	private JMenu AboutMenu   = new JMenu("?");
    
    // File 
	private JMenuItem Exit   = new JMenuItem("Exit",new ImageIcon(this.getClass().getResource("exit.png")));
    private JMenuItem NewContact  = new JMenuItem("New Contact",new ImageIcon(this.getClass().getResource("newcontact.png")));
    private JMenuItem NewGroup   = new JMenuItem("New Group",new ImageIcon(this.getClass().getResource("newgroup.png")));
    private JMenuItem Prefs   = new JMenuItem("Preferences",new ImageIcon(this.getClass().getResource("prefs.png")));
    private JMenuItem Update   = new JMenuItem("Reload",new ImageIcon(this.getClass().getResource("reload.png")));
    private JMenuItem Save    = new JMenuItem("Save",new ImageIcon(this.getClass().getResource("save.png")));
    private JMenuItem SaveAs   = new JMenuItem("Save As...",new ImageIcon(this.getClass().getResource("save.png")));
    private JMenuItem DelContact  = new JMenuItem("Delete",new ImageIcon(this.getClass().getResource("delete.png")));
    
	// Edit  
    private JMenuItem Copy     = new JMenuItem("Copy", 'c');
    private JMenuItem Copy_list    = new JMenuItem("Copy List",'l');
    private JMenuItem EditContact  = new JMenuItem("Edit Contact");
    private JMenuItem EditGroups  = new JMenuItem("Edit Groups");

	// tools
	private JMenuItem ExportPhonelist	= new JMenuItem("Export Phones");

    // View
    private JCheckBoxMenuItem ToggleEmailListe = new JCheckBoxMenuItem("EmailListe");       
    private JRadioButtonMenuItem but_contacts = new JRadioButtonMenuItem("Contacts",true) ; 
    private JRadioButtonMenuItem but_groups   = new JRadioButtonMenuItem("Groups",false) ;
    private ButtonGroup butgrp_contacts	 	  = new ButtonGroup();
    // About
    private JMenuItem about  		= new JMenuItem("About");
    private JMenuItem debug  		= new JMenuItem("Debug");
		
    // About Dialog 
    private JDialog aboutDialog; 
    private Container aboutPane;
    private JLabel aboutPic 	= new JLabel(new ImageIcon(this.getClass().getResource("logo.jpg")));       
	
	//Filechooser	
	JFileChooser FileChooserDialog;
    // Emailliste rechts
    public Vector SelectedEmail		= new Vector();
    public JList ListSelectedEmail	= new JList(SelectedEmail);
    public JScrollPane SelectedEmail_scroll	= new JScrollPane(ListSelectedEmail); 
    public JButton but_AddSelectedEmail    	= new JButton("add",new ImageIcon(this.getClass().getResource("add.png")));
    public JButton but_RemSelectedEmail 	= new JButton("remove",new ImageIcon(this.getClass().getResource("delete.png")));
	
    //Layoutmanager fuer Fenster und Tabs
	GridBagLayout Framelayout 		= new GridBagLayout();
    GridBagLayout RightFramelayout 	= new GridBagLayout();
    GridBagLayout LeftFramelayout 	= new GridBagLayout();
    GridBagLayout Email_tablayout 	= new GridBagLayout();
    GridBagLayout Mail_tablayout 	= new GridBagLayout();
    GridBagLayout General_tablayout = new GridBagLayout();
    GridBagLayout Phone_tablayout 	= new GridBagLayout();
    GridBagLayout Groups_tablayout 	= new GridBagLayout();
    GridBagConstraints gbc;
	
    /*
      || Label fuer Feldnamen, die nicht weiter bearbeitet werden
    */
    // General_tab
    private FeldLabel lab_name		= new FeldLabel("Surname: ");
    private FeldLabel lab_vorname 	= new FeldLabel("Name: ");
    private	FeldLabel lab_nickname 	= new FeldLabel("Nickname: ");
    private FeldLabel lab_bday 		= new FeldLabel("Date of birth: ");
    // Email_tab
    private FeldLabel lab_mailto 	= new FeldLabel("mailto: ");	
    private FeldLabel lab_email_komm = new FeldLabel("Comment: ");
    // Mail_tab
    private FeldLabel lab_anschrift	= new FeldLabel("Address: ");
    private FeldLabel lab_plz	 	= new FeldLabel("ZIP-Code: ");
    private	FeldLabel lab_stadt 	= new FeldLabel("City: ");
    private FeldLabel lab_land		= new FeldLabel("Country: ");
    private FeldLabel lab_adress_komm = new FeldLabel("Comment: ");
    // Phone_tab
    private FeldLabel lab_telefonnr	= new FeldLabel("Number: ");	
    private FeldLabel lab_telefon_komm = new FeldLabel("Comment: ");
    private FeldLabel lab_telefontyp = new FeldLabel("Type: ");	
	
    /*
      || Label die Personenbezogen ihren Text aendern
    */
    // Eigenschaften in General_tab 
    public TextLabel Vname    = new TextLabel();
    public TextLabel Nname    = new TextLabel();
    public TextLabel Nickname = new TextLabel();
    public TextLabel Bday 	  = new TextLabel();
    //  Eigenschaften in Email_tab 
    public TextLabel Email      = new TextLabel();
    public TextLabel Email_komm = new TextLabel();
    public JList  Email_list 	= new JList();
    public JScrollPane Email_scroll= new JScrollPane(Email_list); 
    //  Eigenschaften in Mail_tab 
    public TextLabel Anschrift   = new TextLabel();
    public TextLabel Plz		 = new TextLabel();
    public TextLabel Stadt		 = new TextLabel();
    public TextLabel Land		 = new TextLabel();
    public TextLabel Anschrift_komm 	= new TextLabel();
    public JList  Anschrift_list 	 	= new JList();
    public JScrollPane Anschrift_scroll	= new JScrollPane(Anschrift_list); 	
    //  Eigenschaften in Phone_tab 
    public TextLabel Telefonnr  	= new TextLabel();
    public TextLabel Telefon_komm 	= new TextLabel();
    public TextLabel Telefontyp 	= new TextLabel();
    public JList  Telefon_list 		= new JList();
    public JScrollPane Telefon_scroll = new JScrollPane(Telefon_list);
    // Properties for Group_tab
    private FeldLabel lab_groups 	= new FeldLabel("Member in Groups: ");	
    public JList  GroupList 		= new JList();
    public JScrollPane Group_scroll = new JScrollPane(GroupList); 	
	
	
	
    // Konstruktor	
    public Fenster(String name){
		// initializing ControlModule
		Control = new FensterControl(this);
		//Titel und icon
		setTitle(name);
		setLocation(30,30);
		setIconImage(getToolkit().getImage(this.getClass().getResource("icon.png")));
		// Container fuer Komponenten
		rahmen = this.getContentPane();

		// im Rahmen Dinge dynamisch verteilen
		rahmen.setLayout(Framelayout);
		rahmen.add(MenuBar);
		//Menu zusammenbasteln
		NewItems.add(NewContact);
		NewItems.add(NewGroup);
		FileMenu.add(NewItems);
		FileMenu.add(DelContact);
		FileMenu.addSeparator();
		FileMenu.add(Prefs);
		FileMenu.add(Update);
		FileMenu.add(Save);
		FileMenu.add(SaveAs);
		FileMenu.addSeparator();
		FileMenu.add(Exit);
				
		// EditMenu zusammenbasteln
		EditMenu.add(EditContact);
		EditMenu.add(EditGroups);
		EditMenu.addSeparator();
		EditMenu.add(Copy);
		EditMenu.add(Copy_list);
				
		// View Menu
		butgrp_contacts.add(but_contacts);
		butgrp_contacts.add(but_groups);  
		ViewMenu.add(but_contacts); 
		ViewMenu.add(but_groups); 
		ViewMenu.add(ToggleEmailListe);
		
		//Tools Menu
		ToolsMenu.add(ExportPhonelist);
		ExportPhonelist.setEnabled(false);
		
		//About Dialog
		AboutMenu.add(about); 
		aboutDialog = new JDialog(this, "About AddMan");                                                 
		aboutPane 	= aboutDialog.getContentPane();                                                
		aboutPane.add(aboutPic);
		aboutDialog.pack();
		aboutDialog.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		// AboutMenu.add(debug);
		
		//Hotkeys
		but_AddSelectedEmail.setMnemonic('+');
		but_RemSelectedEmail.setMnemonic('-');
		Exit.setMnemonic('Q');
		NewContact.setMnemonic('N');
		EditMenu.setMnemonic('E');
		FileMenu.setMnemonic('F');
		EditContact.setAccelerator(KeyStroke.getKeyStroke('E', Event.CTRL_MASK));
		Copy.setAccelerator(KeyStroke.getKeyStroke('C', Event.CTRL_MASK));
		Copy_list.setAccelerator(KeyStroke.getKeyStroke('L', Event.CTRL_MASK));
		
		//Menu zusammenbauen	
		MenuBar.add(FileMenu);
		MenuBar.add(EditMenu);
		MenuBar.add(ViewMenu);			
		MenuBar.add(ToolsMenu);			
		MenuBar.add(AboutMenu);
						
		/*******************
		 * LAYOUT
		 ******************/

		// Layout  im linken Rahmen
		KisteLinks.setLayout(LeftFramelayout);
		KisteLinks.setPreferredSize(new Dimension(130,240));
		gbc = makegrid(0,0,1,1,100,0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		lab_listtitle.setPreferredSize(new Dimension(130,25));
		LeftFramelayout.setConstraints(lab_listtitle,gbc);
		KisteLinks.add(lab_listtitle);
		gbc = makegrid(0,1,1,2,1,1);
		gbc.fill = GridBagConstraints.BOTH;
		UserScroll.setPreferredSize(new Dimension(130, 215));
		LeftFramelayout.setConstraints(UserScroll,gbc);
		KisteLinks.add(UserScroll);

		// Layout im mittleren Rahmen 
		KisteMitte.setPreferredSize(new Dimension(250, 240));
		KisteMitte.addTab("General",new ImageIcon(this.getClass().getResource("general.png"))	, General_tab,"gereral information");
		KisteMitte.addTab("Mail"   ,new ImageIcon(this.getClass().getResource("anschrift.png"))	, Mail_tab,  "snailmail");
		KisteMitte.addTab("Email"  ,new ImageIcon(this.getClass().getResource("email.png"))		, Email_tab, "email list");
		KisteMitte.addTab("Phone"  ,new ImageIcon(this.getClass().getResource("phone.png")), Phone_tab, "telephone");
		KisteMitte.addTab("Groups" ,new ImageIcon(this.getClass().getResource("newgroup.png"))	, Groups_tab,"mail groups");

		// Alle TabbedPanes "layouten"
		tabLayout();		
		// Layout  im rechten, unsichtbaren  Rahmen
		KisteUnten.setPreferredSize(new Dimension(390, 75));
		KisteUnten.setLayout(RightFramelayout);
		gbc = makegrid(0,0,2,2,100,100);
		gbc.fill = GridBagConstraints.BOTH;
		SelectedEmail_scroll.setPreferredSize(new Dimension(290, 75));
		SelectedEmail_scroll.setMinimumSize(new Dimension(285, 75));
		RightFramelayout.setConstraints(SelectedEmail_scroll,gbc);
		KisteUnten.add(SelectedEmail_scroll);		
		gbc = makegrid(2,0,1,1,80,0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		but_AddSelectedEmail.setPreferredSize(new Dimension(100, 35));
		but_AddSelectedEmail.setMinimumSize(new Dimension(95, 35));
		RightFramelayout.setConstraints(but_AddSelectedEmail,gbc);
		KisteUnten.add(but_AddSelectedEmail);	
		gbc = makegrid(2,1,1,1,80,0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		but_RemSelectedEmail.setPreferredSize(new Dimension(100,35));
		but_AddSelectedEmail.setMinimumSize(new Dimension(95, 35));
		RightFramelayout.setConstraints(but_RemSelectedEmail,gbc);
		KisteUnten.add(but_RemSelectedEmail);
			
		//Layout im Hauptrahmen	
		//Menu ins Fenster
		this.setJMenuBar(MenuBar);
		//Linke Kiste
		gbc = makegrid(0,0,1,2);
		gbc.fill = GridBagConstraints.BOTH;
		Framelayout.setConstraints(KisteLinks,gbc);
		rahmen.add(KisteLinks);
		//Mittlere Kiste
		gbc = makegrid(1,0,1,2);
		gbc.fill = GridBagConstraints.BOTH;
		Framelayout.setConstraints(KisteMitte,gbc);
		rahmen.add(KisteMitte);
		//Rechte Kiste
		gbc = makegrid(0,2,2,1);
		gbc.fill = GridBagConstraints.BOTH;
		Framelayout.setConstraints(KisteUnten,gbc);
		KisteUnten.setVisible(false);
		rahmen.add(KisteUnten);
  
		/**
		   Action Listener 
		*/
 
		// Event fuer fenster
		this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent evt){
					if(AddMan.datachanged){
						showExitDialog();
					}
					else{
						System.exit(0);
					}
				}
			});
  
		//ButtonEvent "ADD"
		but_AddSelectedEmail.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt){
					add_remove(evt);
				}
			});
		//ButtonEvent "Remove"
		but_RemSelectedEmail.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent evt){
					add_remove(evt);
				}
			});
  
  
		//ActionListener fuer EditMenu
		ActionListener EditMenuListener = new ActionListener() {
				public void actionPerformed(ActionEvent e){
					String arg = e.getActionCommand();
					AddressClipboard MyClipboard;
					if (arg.equals("Copy")) {
						if( Email.getText() != null){
							AddressClipboard myClip = new AddressClipboard(Email.getText());
						}

					}
					else if(arg.equals("Copy List") && SelectedEmail.size() != 0){
						String emailtextliste = "";
						Email adresse;
						for(java.util.Enumeration enu = SelectedEmail.elements(); enu.hasMoreElements(); ){
							adresse = ((Email) enu.nextElement());
							emailtextliste +=  adresse.toString() + AddMan.SEPARATOR;
						}
						// Letztes ueberschuessiges Semicolon entfernen
						emailtextliste = emailtextliste.substring(0,emailtextliste.length()-1);
						AddressClipboard myClip = new AddressClipboard(emailtextliste);
					}
					else if(arg.equals("Edit Contact")){
						if(AddMan.Kontakt != null) EditFenster.getInstance();
					}
					else if(arg.equals("Edit Groups")){
						GroupWindow.getInstance(AddMan.getGroups().toArray());
					}
				}
			}; 
		// ActionListener fuer FileMenu
		ActionListener FileMenuListener = new ActionListener(){
				public void actionPerformed(ActionEvent e){
					String arg = e.getActionCommand();
					if (arg.equals("New Contact")) {
						AddMan.Kontakt = new Person();
						AddMan.myUsers.add(AddMan.Kontakt);
						Collections.sort(AddMan.myUsers);
						UserList.setListData(AddMan.myUsers);
						UserList.setSelectedValue(AddMan.Kontakt,true);
						EditFenster.getInstance();
					}
					else if(arg.equals("New Group")){
						GroupWindow.getInstance(AddMan.getGroups().toArray());
					}
					else if(arg.equals("Preferences")){
						PrefsWindow.getInstance(AddMan.AppPrefs);
					}
					else if(arg.equals("Reload")){
						showUpdateWarnDialog();
					}
					else if(arg.equals("Save As...")){
						AddMan.savetoFile();
					}
					else if(arg.equals("Save")){
						AddMan.save(true);
					}
					else if(arg.equals("Delete")){    
						Control.deleteListitem();  
					}
					else if(arg.equals("Exit")){
						if(AddMan.datachanged){
							showExitDialog();
						}
						else{
							System.exit(0);
						}
					}
				}
			};


		//----------------- DEBUG ----------------------------------------------------  
		debug.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					debug();
				}
			});
		//-----------------------------------------------------------------------------
		// Emailliste Rechts an und ausschalten
		ExportPhonelist.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Control.generatePhoneList();
				}
			}); 


  
		// Emailliste Rechts an und ausschalten
		ToggleEmailListe.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Liste_einblenden();
				}
			}); 
  
		/*
		  || Switch View between Groups and Contacts
		*/ 
  
		// Show Contacts
		but_contacts.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					viewContacts();
				}
			}); 
		
		//Show Groups
		but_groups.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					viewGroups();
				}
			}); 
		
		/*
		  || ActionListener Fuer Listen
		*/		
		
		//UserListe
		UserList.addListSelectionListener(new ListSelectionListener(){
				private JList source;
				private Person myperson;
				public void valueChanged(ListSelectionEvent e){
					source = (JList)e.getSource();
					if ( (myperson = (Person)source.getSelectedValue()) != null){
						AddMan.Kontakt = myperson;
						updateData(AddMan.Kontakt);
					}
					//Falls ein EditFenster offen ist muessen die Daten aktualisiert werden
					if(EditFenster.exists() != null){
						EditFenster.exists().updateData();
					}
				}
			});
  
		// GroupList
		globGroupList.addListSelectionListener(new ListSelectionListener(){
				public void valueChanged(ListSelectionEvent e){
					selectGroups();
				}
			});
  
		/*
		  ||Listen Sollen auf Doppelklick reagieren und Edit Fenster oeffnen
		*/
		//Doppelklick UserList  
		UserList.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if(me.getClickCount() == 2) {
						if(Selectionmode == AddMan.USERSELECTIONMODE)
								EditFenster.getInstance(); 
 					} 
				}
			});
    
		//Doppelklick globale GruppenListe
		globGroupList.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if (me.getClickCount() == 2) {
						if(Selectionmode == AddMan.GROUPSELECTIONMODE)
								GroupWindow.getInstance(AddMan.getGroups().toArray()); 
					} 
				}
			});


		//Doppelklick Addressliste  
		Anschrift_list.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if(me.getClickCount() == 2) {
                      if(Selectionmode == AddMan.USERSELECTIONMODE){
						EditFenster.getInstance();
                        EditFenster.Reiter.setSelectedIndex(1);
                      }
					} 
				}
			});

	//Doppelklick Telefonliste  
		Telefon_list.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if(me.getClickCount() == 2) {
                      if(Selectionmode == AddMan.USERSELECTIONMODE){
						EditFenster.getInstance();
                        EditFenster.Reiter.setSelectedIndex(3);
                      }
					} 
				}
			});
    
  	//Doppelklick Addressliste  
		Email_list.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if(me.getClickCount() == 2) {
                      if(Selectionmode == AddMan.USERSELECTIONMODE){
						EditFenster.getInstance();
                        EditFenster.Reiter.setSelectedIndex(2);
                      }
					} 
				}
			});
		/*
		  || ActionListener fuer JTabbedPanes
		*/
		// Auswahl in Emailliste
		Email_list.addListSelectionListener(new ListSelectionListener(){
				public void valueChanged(ListSelectionEvent e){
					selectMail();
				}
			});
		// Auswahl in Addressliste
		Anschrift_list.addListSelectionListener(new ListSelectionListener(){
				public void valueChanged(ListSelectionEvent e){
					selectAnschrift();
				}
			});
		// Auswahl inTelefonliste
		Telefon_list.addListSelectionListener(new ListSelectionListener(){
				public void valueChanged(ListSelectionEvent e){
					selectTelefon();
				}
			});
  
		/*
		  || ActionListener Fuer Menues
		*/
		// Actionlistener EditMenu hinzufuegen...
		Copy.addActionListener(EditMenuListener);
		Copy_list.addActionListener(EditMenuListener);
		EditContact.addActionListener(EditMenuListener);
		EditGroups.addActionListener(EditMenuListener);
		// ActionListener FileMenu hinzufuegen
		NewContact.addActionListener(FileMenuListener);
		NewGroup.addActionListener(FileMenuListener);
		DelContact.addActionListener(FileMenuListener);
		Prefs.addActionListener(FileMenuListener);
		Update.addActionListener(FileMenuListener);
		Save.addActionListener(FileMenuListener);
		SaveAs.addActionListener(FileMenuListener);
		Exit.addActionListener(FileMenuListener);
		
		// AboutMenu
		about.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					aboutAction(evt);
				}
			});
		
		pack();
    } // Ende Construktor

    /*
      || Methoden fuer ActionListener
    */
		
    //--------------------------- DEBUG -------------------------------------------
    public void debug(){	
		System.out.println("-------- DEBUG  ------");
    }   
    //-------------------------------------------------------------------------------
    // Show Contacts (default)
    public void viewContacts(){
	    this.Selectionmode =AddMan.USERSELECTIONMODE;
		UserList.setSelectedIndex(0);
		KisteLinks.remove(globGroupScroll);	
		lab_listtitle.setText("Contacts:");
		KisteMitte.setEnabled(true);
		KisteMitte.setSelectedComponent(General_tab);
		gbc = makegrid(0,1,1,2);
		gbc.fill = GridBagConstraints.BOTH;
		LeftFramelayout.setConstraints(UserScroll,gbc);
		KisteLinks.add(UserScroll);
		KisteLinks.repaint();	
    }
	
    // Show Groups
    public void viewGroups(){
		this.Selectionmode =AddMan.GROUPSELECTIONMODE;
		KisteLinks.remove(UserScroll);
		AddMan.Kontakt = null;
		updateData(AddMan.Kontakt);
		KisteMitte.setSelectedComponent(Groups_tab);
		KisteMitte.setEnabled(false);
		globGroupList.setListData(AddMan.getGroups().toArray());
		lab_listtitle.setText("Groups:");
		gbc = makegrid(0,1,1,2);
		gbc.fill = GridBagConstraints.BOTH;
		LeftFramelayout.setConstraints(globGroupScroll,gbc);
		KisteLinks.add(globGroupScroll);
		KisteLinks.repaint();	
    }

    // About Dialog darstellen
    public void aboutAction(ActionEvent e) {
		String arg = e.getActionCommand();
		if (arg.equals("About")) {
			aboutDialog.setLocation(this.getLocation());
			aboutDialog.setVisible(true);
		}
    }

    //  Kommentar und angezeigte mailadresse aendern
    public void selectMail(){
		if(Email_list.getSelectedIndex() != -1){
			Email list_item = (Email)Email_list.getSelectedValue();
			Email_komm.setText(list_item.getKomment());
			Email.setText(list_item.getAddress());
		}
    }

    // Anschrift Lables fuellen
    public void selectAnschrift(){
		if(Anschrift_list.getSelectedIndex() != -1){
			Postadresse list_item = (Postadresse)Anschrift_list.getSelectedValue();
			Anschrift_komm.setText(list_item.getKomment());
			Anschrift.setText(list_item.getAnschrift());
			Land.setText(list_item.getLand());
			Stadt.setText(list_item.getStadt());
			Plz.setText(list_item.getPLZ());
		}
    }
    // TelefonLabels fuellen
    public void selectTelefon(){	
		if(Telefon_list.getSelectedIndex() != -1){
			Telefon list_item = (Telefon) Telefon_list.getSelectedValue();
			Telefonnr.setText(list_item.getNummer());
			Telefontyp.setText(AddMan.TelefonTypListe[list_item.getTyp()]);
			Telefon_komm.setText(list_item.getKomment());
		}
    }
	
    /** 
     * If Groupselectionmode is activated the Groupstab is abused 
     * for displaying members of the selected Group
     */
    public void selectGroups(){
		if(globGroupList.getSelectedIndex() != -1){
			Group list_item = (Group)globGroupList.getSelectedValue();
			GroupList.setListData(list_item.getMembers());
		}
    }
	
	

    /** update data General_tab clear list if myperson == null*/
    public void updateGeneral_tab(Person myperson) {
		if(myperson == null){
			Vname.setText(null);       
			Nname.setText(null);       
			Nickname.setText(null); 
			Bday.setText(null);    
		}
		else{
			Vname.setText(myperson.getVname());
			Nname.setText(myperson.getNname());
			Nickname.setText(myperson.getNickname());
			Bday.setText(myperson.getBday());    
		}
    }       
            
    /** update data Email_tab clear list if myperson == null*/
    public void updateEmail_tab(Person myperson){
		if(myperson == null){
			Email_list.setListData(new Vector());
			Email.setText(null);
			Email_komm.setText(null);
		}
		else{
			Email_list.setListData((myperson.getEmail()).toArray());         
			// Wenn es Keine Email  gibt kann auch kein Label gesetzt werden
			if((myperson.getEmail()).toArray().length > 0){
				Email_list.setSelectedIndex(0);
			}
			else{
				Email.setText(null);
				Email_komm.setText(null);
			}
		}
    }
	
    /** update data Mail_tab clear list if myperson == null*/
    public void updateMail_tab(Person myperson){
		if(myperson == null){
			Anschrift.setText(null);
			Plz.setText(null);
			Stadt.setText(null);
			Land.setText(null);
			Anschrift_komm.setText(null);
			Anschrift_list.setListData(new Vector());
		}
		else{
			Anschrift_list.setListData((myperson.getPostAddress()).toArray());
			if((myperson.getPostAddress()).toArray().length > 0){
					Anschrift_list.setSelectedIndex(0);
			}
			// Wenn es Keine Adresse  gibt kann auch kein Label gesetzt werden
			else{
				Anschrift.setText(null);
				Plz.setText(null);
				Stadt.setText(null);
				Land.setText(null);
				Anschrift_komm.setText(null);
			}
		}
    }


    /** update data Phone_tab clear list if myperson == null*/
    public void updatePhone_tab(Person myperson){
		if(myperson == null){  
			Telefonnr.setText(null);
			Telefon_komm.setText(null);
			Telefontyp.setText(null);
			Telefon_list.setListData(new Vector());
		}
		else{
			Telefon_list.setListData((myperson.getTelefon()).toArray());
			// Wenn es Keine Adresse  gibt kann auch kein Label gesetzt werden
			if((myperson.getTelefon()).toArray().length >0){
				Telefon_list.setSelectedIndex(0);
			}
			else{
				Telefonnr.setText(null);
				Telefon_komm.setText(null);
				Telefontyp.setText(null);
			}
		}
    }
 
    /** update data Groups_tab clear list if myperson == null*/
    public void updateGroups_tab(Person myperson){
		if(myperson == null){
			GroupList.setListData(new Vector()); 
		}
		else{
			GroupList.setListData((myperson.getGroups()).toArray());
		}
    }
 
 
    /** update data of all tabs with one call */
    public void updateData(Person mycontact){
		updateGeneral_tab(mycontact);
		updateMail_tab(mycontact);
		updateEmail_tab(mycontact);
		updatePhone_tab(mycontact);
		updateGroups_tab(mycontact);
    }
 
    // Liste Unten erweitern oder Verkleinern
    public void add_remove(ActionEvent e){
		String arg = e.getActionCommand();
		if(arg.equals("add")){
			// Check ob Gruppen oder User angezeigt sind
			if (this.Selectionmode == AddMan.GROUPSELECTIONMODE){
				/*
				  || Sind in der Grouplist mehrere Gruppen ausgewaehlt, 
				  || so wird von jedem nur die Defaultaddresse eingetragen
				*/
				Object[] SelectedGroups = globGroupList.getSelectedValues();
				if(SelectedGroups.length > 0){
					for(int i=0; i < SelectedGroups.length ; i++ ){
						Group tmpgrp = (Group)SelectedGroups[i];
						for(java.util.Enumeration en = tmpgrp.getMembers().elements(); en.hasMoreElements();){						
							SelectedEmail.add(0,(Email)en.nextElement());
						}	
					}
				}		
			}
			else if (this.Selectionmode == AddMan.USERSELECTIONMODE){
				/**
				 * Sind in der Userliste mehrere Leute ausgewaehlt, 
				 * so wird von jedem nur die Defaultaddresse eingetragen
				 */
				Object[] SelectedUser = UserList.getSelectedValues();
				if(SelectedUser.length > 1){
					for(int i=0; i < SelectedUser.length ; i++ ){
						try{
							if( ((Person)SelectedUser[i]).getDefaultEmail() != null ){
								SelectedEmail.add(0,((Person)SelectedUser[i]).getDefaultEmail());
							}
						}
						catch(Exception gexc){
							AddMan.win.showErrorMessage( "Error occured (Fenster.add_remove())" + ((Person)SelectedUser[i]).getVname() + gexc.getMessage());
						}
					}
				}
				// Sonst wird die im Email_tab ausgewaehlte Addresse benutzt
				else if(SelectedUser.length == 1){ 
					if(Email_list.getSelectedValue()!=null){
						SelectedEmail.add(0,Email_list.getSelectedValue());
					}
				}
			
			}			
			// Auswahl in der Liste setzen
			try{
				ListSelectedEmail.setListData(SelectedEmail);
				ListSelectedEmail.setSelectedIndex(0);
			}
			catch(java.lang.ArrayIndexOutOfBoundsException exc){
				AddMan.win.showErrorMessage("(Fenster.add_remove) " + exc.getMessage() );
			}	
		}	
		
		else if(arg.equals("remove")){
			try{
				int[] selection = ListSelectedEmail.getSelectedIndices();
				for(int i = 0; i < selection.length; i++){
					SelectedEmail.removeElementAt(selection[i]);
				}
				ListSelectedEmail.setListData(SelectedEmail);
				if(SelectedEmail.isEmpty() != true)ListSelectedEmail.setSelectedIndex(0);
			}
			catch(java.lang.ArrayIndexOutOfBoundsException exc){
			}
		}
    }

    // Fenster erweitern wenn email gechecked
    public void Liste_einblenden(){
		if (ToggleEmailListe.getState() == true) {
			KisteUnten.setVisible(true);
			this.pack();
		}
		else{
			KisteUnten.setVisible(false);
			this.pack();
		}
    }

    /*
      || Layoutmanager braucht fuer jedes item neue Constraints.
      || UEberladene Funktion um eine defaultskalierung zu erreichen
    */
    // Aufruf mit eigener Skalierung
    public static GridBagConstraints makegrid (int x_pos,int y_pos, int x_size,int y_size, int scalex, int scaley){
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = x_pos;
		gbc.gridy = y_pos;
		gbc.gridwidth  = x_size;
		gbc.gridheight = y_size;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(1,1,1,1);
		gbc.weightx = scalex;
		gbc.weighty = scaley;
		return gbc;
    }
    //Aufruf mit Defaultskalierung
    public static GridBagConstraints makegrid (int x_pos,int y_pos, int x_size,int y_size){
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = x_pos;
		gbc.gridy = y_pos;
		gbc.gridwidth  = x_size;
		gbc.gridheight = y_size;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(1,1,1,1);
		gbc.weightx = 100;
		gbc.weighty = 100;
		return gbc;
    }
	
    /** Method to show ExitDialog  */
    public int showExitDialog(){
		Object[] options = {"Save","Revoke", "Cancel"};
    	int n = JOptionPane.showOptionDialog(this,
				"Do you want to save changes to database ",
				"Save Your work?",
				JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				options,
				options[0]);
		if (n == JOptionPane.YES_OPTION) {
			AddMan.save(true);
			System.exit(0);
			return JOptionPane.YES_OPTION;
		} else if (n == JOptionPane.NO_OPTION) {
			AddMan.save(false);
			System.exit(0);
			return JOptionPane.NO_OPTION;
		} else if (n == JOptionPane.CANCEL_OPTION) {
			AddMan.win.setVisible(true);
			return JOptionPane.CANCEL_OPTION;
		} else {
			AddMan.win.setVisible(true);
			return JOptionPane.CLOSED_OPTION;
		}	
    }
	
    /** Method shows WarnDialog before updating */	
    public int showUpdateWarnDialog(){
		Object[] options = {"Ok", "Cancel"};
    	int n = JOptionPane.showOptionDialog(this,
				"All Changes will be lost",
				"Save Your work?",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.WARNING_MESSAGE,
				null,
				options,
				options[0]);
		if (n == JOptionPane.YES_OPTION) {
			AddMan.initData();
			return JOptionPane.YES_OPTION;
		} else if (n == JOptionPane.NO_OPTION){
			return JOptionPane.NO_OPTION;
		} else {
			return JOptionPane.CLOSED_OPTION;
		}	
    }
		
	/** Global Error Display method */		
	public static void showErrorMessage(String ErrorString){
		// Format the String at leas every 55 CHARS a newline
		int i = 55;
		while( i < ErrorString.length()){
			try{
				while(ErrorString.charAt(i) != ' '){
					i--;		
				}
				ErrorString=ErrorString.substring(0,i)+"\n"+ErrorString.substring(i+1,ErrorString.length());
			}
			catch(IndexOutOfBoundsException exc){}
			i+=55;
		}   	
	    JOptionPane.showMessageDialog(null, ErrorString,"Error",
				JOptionPane.ERROR_MESSAGE);
	}	


    /*
      || Methode Layouted alle TabbedPanes im mittleren Rahmen
    */
    public void tabLayout(){
		/*
		  ||  Layout fuer Generaltab:
		*/
		General_tab.setLayout(General_tablayout);
		//Nachname Feld 
		gbc = makegrid(0,0,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(lab_name,gbc);
		General_tab.add(lab_name);
		//Nachname Daten
		gbc = makegrid(1,0,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(Nname,gbc);
		General_tab.add(Nname);
		//Vorname Feld
		gbc = makegrid(0,1,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(lab_vorname,gbc);
		General_tab.add(lab_vorname);
		// Vorname Daten
		gbc = makegrid(1,1,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(Vname,gbc);
		General_tab.add(Vname);
		// Nichname Feld
		gbc = makegrid(0,2,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(lab_nickname,gbc);
		General_tab.add(lab_nickname);
		// Nickname Daten
		gbc = makegrid(1,2,1,1,100,0);
		gbc.anchor = GridBagConstraints.WEST;
		General_tablayout.setConstraints(Nickname,gbc);
		General_tab.add(Nickname);
		//Geburtstag - Feld
		gbc = makegrid(0,3,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(lab_bday,gbc);
		General_tab.add(lab_bday);
		//Geburtstag - Daten
		gbc = makegrid(1,3,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		General_tablayout.setConstraints(Bday,gbc);
		General_tab.add(Bday);
		
		/*		
			||Layout fuer Emailtab:
		*/
		Email_tab.setLayout(Email_tablayout);
		//Email Feld
		gbc = makegrid(0,0,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Email_tablayout.setConstraints(lab_mailto,gbc);
		Email_tab.add(lab_mailto);
		// Email Daten
		gbc = makegrid(0,1,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Email_tablayout.setConstraints(Email,gbc);
		Email_tab.add(Email);
		//Kommentar  Feld
		gbc = makegrid(0,2,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Email_tablayout.setConstraints(lab_email_komm,gbc);
		Email_tab.add(lab_email_komm);
		//Kommentar Daten
		gbc = makegrid(0,3,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Email_tablayout.setConstraints(Email_komm,gbc);
		Email_tab.add(Email_komm);
		// Liste der Emailaddressen
		gbc = makegrid(0,5,2,1);
		gbc.fill = GridBagConstraints.BOTH;
		Email_tablayout.setConstraints(Email_scroll,gbc);
		Email_tab.add(Email_scroll);
		
		/*
		  || Layout fuer Addresstab
		*/
		Mail_tab.setLayout(Mail_tablayout);
		//Anschrift Feld 
		gbc = makegrid(0,0,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(lab_anschrift,gbc);
		Mail_tab.add(lab_anschrift);
		//Anschrift  Daten
		gbc = makegrid(0,1,2,1);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(Anschrift,gbc);
		Mail_tab.add(Anschrift);
		//PLZ Feld
		gbc = makegrid(0,2,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(lab_plz,gbc);
		Mail_tab.add(lab_plz);
		// PLZ Daten
		gbc = makegrid(1,2,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(Plz,gbc);
		Mail_tab.add(Plz);
		// Stadt Feld
		gbc = makegrid(0,3,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(lab_stadt,gbc);
		Mail_tab.add(lab_stadt);
		// Stadt Daten
		gbc = makegrid(1,3,1,1,100,0);
		gbc.anchor = GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(Stadt,gbc);
		Mail_tab.add(Stadt);
		//Land - Feld
		gbc = makegrid(0,4,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(lab_land,gbc);
		Mail_tab.add(lab_land);
		//Land - Daten
		gbc = makegrid(1,4,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(Land,gbc);
		Mail_tab.add(Land);
		//Anschrift - Kommentar feld
		gbc = makegrid(0,5,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(lab_adress_komm,gbc);
		Mail_tab.add(lab_adress_komm);
		//Anschrift - KommentarDaten
		gbc = makegrid(0,6,2,2);
		gbc.anchor= GridBagConstraints.WEST;
		Mail_tablayout.setConstraints(Anschrift_komm,gbc);
		Mail_tab.add(Anschrift_komm);
		// Liste der Postaddressen
		gbc = makegrid(0,8,2,2);
		gbc.fill = GridBagConstraints.BOTH;
		Mail_tablayout.setConstraints(Anschrift_scroll,gbc);
		Mail_tab.add(Anschrift_scroll);
		
		/*
		  || Layout fur Phone_tab
		*/
		Phone_tab.setLayout(Phone_tablayout);
		//TelefonnrFeld 
		gbc = makegrid(0,0,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(lab_telefonnr,gbc);
		Phone_tab.add(lab_telefonnr);
		//Telefonnr  Daten
		gbc = makegrid(1,0,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(Telefonnr,gbc);
		Phone_tab.add(Telefonnr);
		//TelefonTyp Feld
		gbc = makegrid(0,1,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(lab_telefontyp,gbc);
		Phone_tab.add(lab_telefontyp);
		// Telefontyp Daten
		gbc = makegrid(1,1,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(Telefontyp,gbc);
		Phone_tab.add(Telefontyp);
		// Kommentar
		gbc = makegrid(0,2,1,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(lab_telefon_komm,gbc);
		Phone_tab.add(lab_telefon_komm);
		// Kommentar Daten
		gbc = makegrid(1,2,1,1,100,0);
		gbc.anchor = GridBagConstraints.WEST;
		Phone_tablayout.setConstraints(Telefon_komm,gbc);
		Phone_tab.add(Telefon_komm);
		// Liste der Telefonnummern
		gbc = makegrid(0,3,2,2);
		gbc.fill = GridBagConstraints.BOTH;
		Phone_tablayout.setConstraints(Telefon_scroll,gbc);
		Phone_tab.add(Telefon_scroll);
		
		/*		
			||Layout Group_tab:
		*/
		Groups_tab.setLayout(Groups_tablayout);
		//Group Feld
		gbc = makegrid(0,0,2,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		Groups_tablayout.setConstraints(lab_groups,gbc);
		Groups_tab.add(lab_groups);
		// Group Daten
		gbc = makegrid(0,1,2,1,100,100);
		gbc.anchor= GridBagConstraints.WEST;
		Groups_tablayout.setConstraints(Group_scroll,gbc);
		Groups_tab.add(Group_scroll);	
    }
	
	
	/**  FileChooser to open files, modal to Fenster */
	public File showOpenFileChooser(){
		if(FileChooserDialog == null){
			FileChooserDialog = new JFileChooser();
		}
		if(FileChooserDialog.showOpenDialog(this) != JFileChooser.CANCEL_OPTION){		
			return FileChooserDialog.getSelectedFile();
		}
		return null;
	}
	

	/**  FileChooser to save files, modal to Fenster */
	public File showSaveFileChooser(){
		if(FileChooserDialog == null){
			FileChooserDialog = new JFileChooser();
		}
		if(FileChooserDialog.showSaveDialog(this) != JFileChooser.CANCEL_OPTION){
			return FileChooserDialog.getSelectedFile();
		}
		return null;
	}	
}	
