/************************************   Group   ********************************
// Java-Addressmanager - Frontend for managing personal contacts
// Copyright (c) 2002  - Thomas Ruschival & Gregor Zurowski
//		 For  license details read LICENSE
// CVS:
// $Author: ruschi $
// $Date: 2004/09/14 15:33:04 $
// $Revision: 1.2 $
//
*******************************************************************************/
import java.util.*;

public class Group{
	//Eigenschaften
	private int  PKEY;
	private String Name;
	private int Farbwert;
	// Alle Emailaddressen zur Gruppe
	private Vector Members = new Vector();

	//Pruefflag  Objekt wurde veraendert
	boolean Modified = false;

	//Constructor
	public Group(int GroupId, String GroupName,int farbe){
		this.PKEY	 	= GroupId;
		this.Name		= GroupName;
		this.Farbwert	= farbe;
	}

	//Constructor
	public Group(int GroupId, String GroupName){
		this.PKEY	 	= GroupId;
		this.Name		= GroupName;
		this.Farbwert	= 0;
	}


	public Group(String Groupname){
		this.Name = Groupname;
		this.Modified = true;
		this.PKEY = 0;
	}
/*
|| Methoden zur Kapselung der Daten
*/
	// Primary Key
	public int getPKEY(){
		return this.PKEY;
	}
	// Methode getGroupname() gibt den in der Liste angezeigten Wert zurueck
	public String getGroupname(){
		return this.Name ;
	}
	// Methode toString() gibt den in der Liste angezeigten Wert zurueck
	public String toString(){
		return this.Name ;
	}
	// Farbwert auslesen
	public int getFarbe(){
		return this.Farbwert;
	}
	//Vector mit allen Mitgliedern auslesen
	public Vector getMembers(){
		return this.Members;
	}

/*
|| Emailaddressen in eine Gruppe eintragen und loeschen
*/
	// aufnehmen
	public void RegisterEmail(Email newmember){
		this.Members.add(newmember);
	}

	// loeschen
	public void UnregisterEmail(Email member){
		this.Members.remove(member);
	}

/* 
|| Set data
*/ 
	// Gruppenname setzen
	public void setName(String newname){
		this.Name = newname;
		this.Modified = true;
	}

	// Farbe der Gruppe zuweisen
	public void setFarbe(int farbe){
		this.Farbwert = farbe;
		this.Modified = true;
	}

	/** 
	 * delete group, notigy all memberemail of deletetion
	 */
	public void delete(){
		Iterator it = Members.iterator();
		try{
			Email member;
			while((member = (Email)it.next()) != null){
				member.GroupDeleted(this);
			}
		}
		catch(java.util.NoSuchElementException nonext){}
	}
}
