/***********************************   GroupWindow   ***************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*		 For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.2 $ 
*				 
*******************************************************************************/
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

public class GroupWindow extends JFrame{
	/** Control Module */
	GroupWindowControl Control;	
	/*
	|| GUI-Items
	*/
    // Labels 
    private FeldLabel lab_Groups	= new FeldLabel("Groups");
	// Buttons
    private JButton but_Modify		= new JButton("modify",new ImageIcon("./icons/modify.png"));
    private JButton but_AddGroup	= new JButton("add",new ImageIcon("./icons/add.png"));
    private JButton but_RemGroup	= new JButton("remove",new ImageIcon("./icons/xbutton.png"));
    // Text Fields       
    public JTextField tf_GroupName	= new JTextField(new String(),20);
    // List
    public static JList	GroupList 			= new JList();
	private JScrollPane Group_scroll 	= new JScrollPane(GroupList);
    // Layout
    private static GridBagLayout FrameLayout = new GridBagLayout();
    private static GridBagConstraints gbc;
    private static Container rahmen;

    /*
    || Fields
    */
    
    // Instance of its own
	private static GroupWindow instance = null;

	/*
	|| iniciate Instance
	*/	
	public static GroupWindow getInstance(Object[] listdata) {
      	if(instance == null){
    		instance = new GroupWindow();
			GroupList.setListData(listdata);
    		instance.setIconImage(instance.getToolkit().getImage("./icons/icon.png"));
    		rahmen = instance.getContentPane();
    		rahmen.setLayout(FrameLayout);   	
    		// Set values of items
			instance.readData(listdata);
			instance.setVisible(true);
    		// Load items
    		instance.layoutInstance();
    		
    		/*
    		|| Action Listener
    		*/
    		instance.setDefaultCloseOperation(HIDE_ON_CLOSE);
    		// Selection in GroupList
			instance.GroupList.addListSelectionListener(new ListSelectionListener(){
				public void valueChanged(ListSelectionEvent e){
					instance.selectGroup();	
				}
			});
			
    		// Modify Group
    		instance.but_Modify.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
					instance.Control.setGroupName();
				}	
			});
			// Add Group
    		instance.but_AddGroup.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
					instance.Control.addGroup();
				}	
			});
			// Delete
    		instance.but_RemGroup.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
					instance.Control.remGroup();
				}	
			});
    	}
    	instance.setVisible(true);			
		return instance;  
    }
    
    /*
    || Methods
    */
    
    // Check for Instance
	public static GroupWindow exists(){
		return instance;
	}
	
	/*
	|| Constructor for Singelton
	*/	
	private GroupWindow(){
		super("Edit Groups");
		Control = new GroupWindowControl(this);
	}
	
	/*
	|| Set Values of Fields according AddMan.GroupHash
	*/
	public void readData(Object[] listdata){
		instance.GroupList.setListData(listdata);
		if(listdata.length != 0)
			GroupList.setSelectedIndex(0);
	}
	
	/*
	|| Modify Groups
	*/
	
	// Select a Group
	private void selectGroup(){
		if(GroupList.getSelectedValue() != null )
		tf_GroupName.setText(((Group)GroupList.getSelectedValue()).toString());
	}
	
	/*
	|| Framelayout
	*/	
	private void layoutInstance(){
		gbc = Fenster.makegrid(0,0,3,1,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		FrameLayout.setConstraints(tf_GroupName,gbc);
		rahmen.add(tf_GroupName);
		gbc = Fenster.makegrid(0,1,3,2,100,0);
		gbc.anchor= GridBagConstraints.WEST;
		FrameLayout.setConstraints(Group_scroll,gbc);
		rahmen.add(Group_scroll);
		gbc = Fenster.makegrid(0,3,1,1);
		FrameLayout.setConstraints(but_Modify,gbc);
		rahmen.add(but_Modify);
		gbc = Fenster.makegrid(1,3,1,1);
		FrameLayout.setConstraints(but_AddGroup,gbc);
		rahmen.add(but_AddGroup);
		gbc = Fenster.makegrid(2,3,1,1);
		FrameLayout.setConstraints(but_RemGroup,gbc);
		rahmen.add(but_RemGroup);		
		instance.pack();
	}
}
