/************************************ PrefsWindow  ****************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*		 For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.2 $ 
*				 
*******************************************************************************/

import java.io.File;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;

public class PrefsWindow extends JFrame{ 
    public Preferences PREFS;	
    /*
      || GUI-Items
    */
    // Labels 
//     private FeldLabel lab_DBHost	= new FeldLabel("Database Host");
//     private FeldLabel lab_Port		= new FeldLabel("Port"); 
//     private FeldLabel lab_Instance	= new FeldLabel("Database Name");
//     private FeldLabel lab_DBSchema	= new FeldLabel("Schema");
//     private FeldLabel lab_DBDriver	= new FeldLabel("Database Driver");  
//     private FeldLabel lab_User 		= new FeldLabel("User"); 
//     private FeldLabel lab_Password	= new FeldLabel("Password");
//    private FeldLabel lab_XMLFile   = new FeldLabel("XML File");
    private FeldLabel lab_Separator	= new FeldLabel("Separator");
//     // Buttons
//     private ButtonGroup  butgrp_driver 	= new ButtonGroup();
//     private JRadioButton but_thinDriver = new JRadioButton("JDBC Oracle",false);
//     private JRadioButton but_xmlDriver  = new JRadioButton("XML File",true);
    private JButton but_chooser     	= new JButton("...");
    private JButton but_Save			= new JButton("Save",new ImageIcon("./icons/modify.png"));
    private JButton but_Cancel			= new JButton("Cancel",new ImageIcon("./icons/xbutton.png"));
    // Text Fields       
//     private JTextField DBHost			= new JTextField(new String(),20);
//     private JTextField Port				= new JTextField(new String(),20);
//     private JTextField DBSchema			= new JTextField(new String(),20);
//     private JTextField DBInstance		= new JTextField(new String(),20);
//     private JTextField User				= new JTextField(new String(),8);
    private JTextField Separator		= new JTextField(new String(),5);
//    private JPasswordField Password		= new JPasswordField(new String(),8);  
    private JTextField XMLFile          = new JTextField(new String(),20);
    // Layout
    private static GridBagLayout FrameLayout = new GridBagLayout();
  // private static GridBagLayout DatabasePanelLayout = new GridBagLayout();
    private static GridBagConstraints gbc;
    private static Container rahmen;
//     private static JPanel DriverPanel	= new JPanel();
//     private static TitledBorder	DriverPanelBorder = new TitledBorder(new EtchedBorder(), "Database Driver");
//     private static JPanel 		DatabasePanel	= new JPanel();
//     private static TitledBorder	DatabasePanelBorder = new TitledBorder(new EtchedBorder(), "Database Information");
    private static JPanel 		FilePanel	= new JPanel();
    private static TitledBorder	FilePanelBorder = new TitledBorder(new EtchedBorder(), "XML-File");
    // File chooser dialog
    private JFileChooser FileChooserDialog;
    private File fileselection;
    
    
    /*
    || Fields
    */
    
    // Instance of its own
	private static PrefsWindow instance = null;
	
	/*
	|| iniciate Instance
	*/	
	public static PrefsWindow getInstance(Preferences myprefs) {
      	if(instance == null){
    		instance = new PrefsWindow();
    		instance.PREFS = myprefs;
    		instance.setIconImage(instance.getToolkit().getImage("./icons/icon.png"));
    		rahmen = instance.getContentPane();
    		rahmen.setLayout(FrameLayout);   	
    		// Load items
    		instance.layoutInstance();
			instance.setLocation(40,40);
    		// Commands for buttons
//			instance.but_thinDriver.setActionCommand(DBconn.THIN_DRIVER);
//			instance.but_xmlDriver.setActionCommand("XMLFile");
    		/*
    		|| Action Listener
    		*/
    		// Save Preferences
    		instance.but_Save.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e){
//					ButtonModel selection = instance.butgrp_driver.getSelection(); 	
// 					instance.PREFS.setHost(instance.DBHost.getText());          
// 					instance.PREFS.setInstanceName(instance.DBInstance.getText());  
// 					instance.PREFS.setDBSchema(instance.DBSchema.getText());
// 					instance.PREFS.setPort(instance.Port.getText());          
// 					instance.PREFS.setUser(instance.User.getText());          
// 					instance.PREFS.setPasswd(new String(instance.Password.getPassword()));        
// 					instance.PREFS.setSeparator(instance.Separator.getText());     
// 					instance.PREFS.setDriver(selection.getActionCommand());        
					instance.PREFS.save(".AddMan");
					instance.setVisible(false);
				}	
			});
			// Revert Preferences
    		instance.but_Cancel.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e){
						instance.readData();
						instance.setVisible(false);
					}	
				});
			
// 			instance.but_thinDriver.addActionListener(new ActionListener(){
// 					public void actionPerformed(ActionEvent e){
// 						instance.Port.setEnabled(true);
// 						instance.DBHost.setEnabled(true);
// 						instance.User.setEnabled(true);
// 						instance.Password.setEnabled(true);
// 						instance.DBSchema.setEnabled(true);
// 						instance.DBInstance.setEnabled(true);
// 					}
// 				});
			
			
// 			instance.but_xmlDriver.addActionListener(new ActionListener(){
// 					public void actionPerformed(ActionEvent e){
// 						instance.Port.setEnabled(false);
// 						instance.DBHost.setEnabled(false);
// 						instance.User.setEnabled(false);
// 						instance.Password.setEnabled(false);
// 						instance.DBSchema.setEnabled(false);
// 						instance.DBInstance.setEnabled(false);
// 					}
// 				});
			
			instance.but_chooser.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e ){
						instance.showFileChooser();
					}
				});
    	}	
		// Set values of items
		instance.readData();
		instance.setVisible(true);		
		return instance;  
    }
    
    /*
    || Methods
    */
    
    // Check for Instance
	public static PrefsWindow exists(){
		return instance;
	}
	
	/*
	|| Constructor for Singelton
	*/	
	private PrefsWindow(){
		super("Preferences");
	}
	
	/*
	|| New FileChooser 
	*/
	private void showFileChooser(){
		if(FileChooserDialog == null){
			FileChooserDialog = new JFileChooser();
		}
		if(FileChooserDialog.showOpenDialog(instance) != JFileChooser.CANCEL_OPTION){
			fileselection = FileChooserDialog.getSelectedFile();
		
			try{
				XMLFile.setText(fileselection.getCanonicalPath());
				instance.PREFS.setFilename(fileselection.getCanonicalPath());
			}
			catch(java.io.IOException ioexc){
				AddMan.win.showErrorMessage("[PrefsWindow.showFileChooser()] :" + ioexc.getMessage() );
			}
			catch(NullPointerException npexc){
				AddMan.win.showErrorMessage("Nullpointer (fileselection)[PrefsWindow.showFileChooser()] :" + npexc.getMessage() );
			}
		}
	}
	
	
	/*
	|| Set Values of Fields according AddMan.AppPrefs
	*/
	private void readData(){
// 		DBHost.setText(PREFS.getHost());
// 		DBInstance.setText(PREFS.getInstanceName());
// 		DBSchema.setText(PREFS.getDBSchema());
// 		Port.setText(PREFS.getPort());
// 		User.setText(PREFS.getUser());
// 		Password.setText(PREFS.getPasswd());
 		Separator.setText(PREFS.getSeparator());
		XMLFile.setText(PREFS.getFilename());	
		// Set JButtons
// 		if(PREFS.getDriver().equals(DBconn.THIN_DRIVER)){
// 			but_thinDriver.setSelected(true);
// 		}
// 		else if (PREFS.getDriver().equals("XMLFile")){
// 			but_xmlDriver.setSelected(true);
// 		}
	}
		
	/*
	|| Framelayout
	*/	
	private void layoutInstance(){
		/*
		|| DriverPanel
		*/
// 		DriverPanel.setBorder(DriverPanelBorder);
// 		butgrp_driver.add(but_thinDriver);
// 		butgrp_driver.add(but_xmlDriver);
// 		DriverPanel.add(but_thinDriver);
// 		DriverPanel.add(but_xmlDriver);
	  	/*
		||
		*/
// 		DatabasePanel.setBorder(DatabasePanelBorder);
// 		DatabasePanel.setLayout(DatabasePanelLayout);
// 		// Database Host
// 		gbc = Fenster.makegrid(0,0,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_DBHost,gbc);
// 		DatabasePanel.add(lab_DBHost);
// 		gbc = Fenster.makegrid(1,0,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(DBHost,gbc);
// 		DatabasePanel.add(DBHost);
// 		DBHost.setDisabledTextColor(java.awt.Color.lightGray);
// 		//Tcp/IP Port
// 		gbc = Fenster.makegrid(0,1,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_Port,gbc);
// 		DatabasePanel.add(lab_Port);
// 		gbc = Fenster.makegrid(1,1,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(Port,gbc);
// 		DatabasePanel.add(Port);
// 		Port.setDisabledTextColor(java.awt.Color.lightGray);
// 		// Database Instance
// 		gbc = Fenster.makegrid(0,2,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_Instance,gbc);
// 		DatabasePanel.add(lab_Instance);
// 		gbc = Fenster.makegrid(1,2,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(DBInstance,gbc);
// 		DatabasePanel.add(DBInstance);
// 		// Database DBSchema
// 		gbc = Fenster.makegrid(0,3,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_DBSchema,gbc);
// 		DatabasePanel.add(lab_DBSchema);
// 		gbc = Fenster.makegrid(1,3,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(DBSchema,gbc);
// 		DatabasePanel.add(DBSchema);		
// 		// User
// 		gbc = Fenster.makegrid(0,4,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_User,gbc);
// 		DatabasePanel.add(lab_User);
// 		gbc = Fenster.makegrid(1,4,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(User,gbc);
// 		DatabasePanel.add(User);
// 		// Password
// 		gbc = Fenster.makegrid(0,5,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(lab_Password,gbc);
// 		DatabasePanel.add(lab_Password);
// 		gbc = Fenster.makegrid(1,5,1,1,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		DatabasePanelLayout.setConstraints(Password,gbc);
// 		DatabasePanel.add(Password);
		
		// Path for XML-File
		FilePanel.setBorder(FilePanelBorder);
        //		FilePanel.add(lab_XMLFile);
		FilePanel.add(XMLFile);
		FilePanel.add(but_chooser);
		
		// Assemble Window
// 		gbc = Fenster.makegrid(0,0,2,2,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
// 		FrameLayout.setConstraints(DriverPanel,gbc);
// 		rahmen.add(DriverPanel);
// 		gbc = Fenster.makegrid(0,2,2,2,95,0);
// 		gbc.anchor= GridBagConstraints.WEST;
		//		FrameLayout.setConstraints(DatabasePanel,gbc);
		// rahmen.add(DatabasePanel);
		gbc = Fenster.makegrid(0,4,2,2,95,0);
		gbc.anchor= GridBagConstraints.WEST;
		FrameLayout.setConstraints(FilePanel,gbc);
		rahmen.add(FilePanel);
	
		// Separator
		gbc = Fenster.makegrid(0,6,1,1,95,0);
		gbc.anchor= GridBagConstraints.WEST;
		FrameLayout.setConstraints(lab_Separator,gbc);
		rahmen.add(lab_Separator);
		gbc = Fenster.makegrid(1,6,1,1,0,0);
		gbc.anchor= GridBagConstraints.WEST;
		FrameLayout.setConstraints(Separator,gbc);
		rahmen.add(Separator);
	
		// Buttons
		gbc = Fenster.makegrid(0,7,1,1,0,0);
		FrameLayout.setConstraints(but_Save,gbc);
		rahmen.add(but_Save);	
		gbc = Fenster.makegrid(1,7,1,1,0,0);
		FrameLayout.setConstraints(but_Cancel,gbc);
		rahmen.add(but_Cancel);
		instance.pack();
	}
 }
