/*********************************** jdomXMLwriter ******************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*		 For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.3 $ 
*				 
*******************************************************************************/

import org.jdom.*;
import org.jdom.output.*;
import org.jdom.input.*;
import java.io.*;
import java.util.*;

class jdomData{
	/* XML-Nodes for Basic Userdata */
	private Element UserHeadElement;
	private Element UserElement;
	private Element NameElement;
	private Element FamilynameElement;
	private Element NicknameElement;
	private Element BirthdayElement;
	/* XML-Nodes for saving Snailmail */
	private Element MailHeadElement;
	private Element MailElement;
	private Element StreetElement;
	private Element ZipcodeElement;
	private Element CityElement;
	private Element CountryElement;
	private Element MailCommentElement;
	/* XML-Nodes for saving Email */
	private Element EmailHeadElement;
	private Element EmailElement;
	private Element EmailAddressElement;
	private Element EmailCommentElement;
	private Element EmailGroupHeadElement;
	private Element EmailGroupElement;
	/* XML-Nodes for saving Phone */
	private Element PhoneHeadElement;
	private Element PhoneElement;
	private Element PhoneNumberElement;
	private Element PhoneTypeElement;
	private Element PhoneCommentElement;
	/* List for Saving Groups */
	private Element GroupHeadElement;
	private Element GroupElement;

	/* general Fields */ 
	private File IOFile; 
	private SAXBuilder Sbuilder; 
	private DocType DocumentType;
	private Element RootElement;
	private Document  XMLDoc;


	/** 
	 * Constuctor expects Filehandle for I/O
	 * The DTD can be downloaded at http://www.ruschival.de/AddMan/data.dtd"
	 */
    jdomData(File file){
		RootElement = new Element("Database");
		DocumentType = new DocType("Database","AddMan-DTD", 
								   "data.dtd");	

		IOFile = file;
		XMLDoc = new Document(RootElement,DocumentType);
	}
	
	/**
	 * Read from the previously set File
	 */
	public Document readFile() throws org.jdom.JDOMException {
		Sbuilder = new SAXBuilder();
		Sbuilder.setValidation(true);
		try{
			XMLDoc = Sbuilder.build(IOFile);
		}
		catch(java.io.IOException ioexc){
			AddMan.win.showErrorMessage("[jdomData.readFile()] "+ioexc.getMessage());
		}	
	
		return this.XMLDoc;
	}

	
	/**
	 * Get the value of IOFile.
	 * @return value of IOFile.
	 */
	public File getIOFile() {
		return IOFile;
	}
	
	/**
	 * Set the value of IOFile.
	 * @param v  Value to assign to IOFile.
	 */
	public void setIOFile(File  v) {
		this.IOFile = v;
	}
	


	/**
	 * Get the value of XMLDoc.
	 * @return value of XMLDoc.
	 */
	public Document getXMLDoc() {
		return XMLDoc;
	}




	/** Create specific DOM of userlist */
	public void buildDom(Vector userlist){
		UserHeadElement = new Element("Userlist");
		// Userloop 
		for(Enumeration userenum=userlist.elements() ; userenum.hasMoreElements();){
			Person myUser = (Person) userenum.nextElement();
			UserElement = new Element("Person");
			NameElement = new Element("Name");
			FamilynameElement = new Element("Familyname");
			NicknameElement = new Element("Nickname");
			BirthdayElement = new Element("Birthday");
			UserElement.setAttribute("PKEY",Integer.toString(myUser.getPKEY()));
		    NameElement.addContent(myUser.getVname());	
			FamilynameElement.addContent(myUser.getNname());
			NicknameElement.addContent(myUser.getNickname());
			BirthdayElement.addContent(myUser.getBday());
			UserElement.addContent(NameElement);			
			UserElement.addContent(FamilynameElement);	
			UserElement.addContent(NicknameElement);
			UserElement.addContent(BirthdayElement);
			// Write Mailaddresses 
			ArrayList PostAddressList = myUser.getPostAddress();
			MailHeadElement = new Element("Mailaddresses");
			for(int i=0 ; i< PostAddressList.size(); i++){
				try{
					MailElement = new Element("Mailaddress");			
					MailElement.setAttribute("PKEY",Integer.toString(((Postadresse)PostAddressList.get(i)).getPKEY()));
					CityElement = new Element("City");				
					StreetElement = new Element("Street");				
					ZipcodeElement = new Element("Zipcode");				
					MailCommentElement = new Element("Comment");				
					CountryElement = new Element("Country");
					CityElement.addContent(((Postadresse)PostAddressList.get(i)).getStadt());	
					StreetElement.addContent(((Postadresse)PostAddressList.get(i)).getAnschrift());	
					ZipcodeElement.addContent(((Postadresse)PostAddressList.get(i)).getPLZ());	
					MailCommentElement.addContent(((Postadresse)PostAddressList.get(i)).getKomment());	
					CountryElement.addContent(((Postadresse)PostAddressList.get(i)).getLand());
					MailElement.addContent(CityElement);	
					MailElement.addContent(StreetElement);	
					MailElement.addContent(ZipcodeElement);	
					MailElement.addContent(CountryElement);
					MailElement.addContent(MailCommentElement);		
					MailHeadElement.addContent(MailElement);
				}
				catch(java.lang.IndexOutOfBoundsException exc){}
			}
			UserElement.addContent(MailHeadElement);
			// Write Phone elements 
			ArrayList Phones = myUser.getTelefon();
			PhoneHeadElement =  new Element("Phones");
			for(int i=0 ; i < Phones.size() ; i++){
				try{
					PhoneElement =  new Element("Phone");			
					PhoneElement.setAttribute("PKEY",Integer.toString(((Telefon)Phones.get(i)).getPKEY()));
					PhoneNumberElement = new Element("Number");				
					PhoneTypeElement = new Element("Type");				
					PhoneCommentElement = new Element("Comment");	
					PhoneNumberElement.addContent(((Telefon)Phones.get(i)).getNummer());	
					PhoneTypeElement.addContent(Integer.toString(((Telefon)Phones.get(i)).getTyp()));	
					PhoneCommentElement.addContent(((Telefon)Phones.get(i)).getKomment());
					PhoneElement.addContent(PhoneNumberElement);	
					PhoneElement.addContent(PhoneTypeElement);	
					PhoneElement.addContent(PhoneCommentElement);
					PhoneHeadElement.addContent(PhoneElement);	
				}
				catch(java.lang.IndexOutOfBoundsException exc){}	
			}
			UserElement.addContent(PhoneHeadElement);
			// Write Email Elements 
			ArrayList Emails = myUser.getEmail();
			EmailHeadElement = new Element("Emailaddresses");
			for(int i=0 ; i < Emails.size() ; i++){		   
				try{
					EmailElement = 	new Element("Email");
					EmailElement.setAttribute("PKEY",Integer.toString(((Email)Emails.get(i)).getPKEY()));
					EmailAddressElement = new Element("Mailto");
					EmailCommentElement = new Element("Comment");
					EmailAddressElement.addContent(((Email)Emails.get(i)).getAddress());
					EmailCommentElement.addContent(((Email)Emails.get(i)).getKomment());
					EmailElement.addContent(EmailAddressElement);
					EmailElement.addContent(EmailCommentElement);
					// Write Groups foreach email address in Plaintext
					EmailGroupHeadElement = new Element("Groups");
					ArrayList EmailGroupList = ((Email)Emails.get(i)).getGroups();
					for(int j = 0 ; j <= EmailGroupList.size() ; j++){
						try{
							EmailGroupElement = new Element("Group");
							EmailGroupElement.setAttribute("PKEY",Integer.toString(((Group)EmailGroupList.get(j)).getPKEY()));
							EmailGroupElement.addContent(((Group)EmailGroupList.get(j)).getGroupname());
							EmailGroupHeadElement.addContent(EmailGroupElement);
						}
						catch(java.lang.IndexOutOfBoundsException excEmailGroups){}	
					} 
					EmailElement.addContent(EmailGroupHeadElement);   
				}
				catch(java.lang.IndexOutOfBoundsException excEmail){}
				EmailHeadElement.addContent(EmailElement);
			}
			UserElement.addContent(EmailHeadElement);
			UserHeadElement.addContent(UserElement);		
   		}// Ende User
		RootElement.addContent(UserHeadElement);
		// Append Grouplist to main document  
		GroupHeadElement = new Element("Groups");
		for(Enumeration en = AddMan.GroupHash.keys() ; en.hasMoreElements();){
			Object key = en.nextElement();
			GroupElement = new Element("Group");
			GroupElement.setAttribute("PKEY",key.toString());
			GroupElement.setAttribute("Name",AddMan.GroupHash.get(key).toString());
			GroupHeadElement.addContent(GroupElement);
		}
		RootElement.addContent(GroupHeadElement);
   	}
	
	/**
	 *  writes the DOM to an XML-File 
	 */
	public void writeXMLfile() throws java.io.IOException{
		FileWriter fileout = new FileWriter(IOFile);
		Format form = Format.getPrettyFormat();
		form.setEncoding("UTF-8");
		XMLOutputter xmlout = new XMLOutputter(form);
		xmlout.output(XMLDoc,fileout);
		fileout.flush();
	}

}
